// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: AdventureControl.proto

#ifndef PROTOBUF_INCLUDED_AdventureControl_2eproto
#define PROTOBUF_INCLUDED_AdventureControl_2eproto

#include <string>

#include <google/protobuf/stubs/common.h>

#if GOOGLE_PROTOBUF_VERSION < 3006001
#error This file was generated by a newer version of protoc which is
#error incompatible with your Protocol Buffer headers.  Please update
#error your headers.
#endif
#if 3006001 < GOOGLE_PROTOBUF_MIN_PROTOC_VERSION
#error This file was generated by an older version of protoc which is
#error incompatible with your Protocol Buffer headers.  Please
#error regenerate this file with a newer version of protoc.
#endif

#include <google/protobuf/io/coded_stream.h>
#include <google/protobuf/arena.h>
#include <google/protobuf/arenastring.h>
#include <google/protobuf/generated_message_table_driven.h>
#include <google/protobuf/generated_message_util.h>
#include <google/protobuf/inlined_string_field.h>
#include <google/protobuf/metadata_lite.h>
#include <google/protobuf/message_lite.h>
#include <google/protobuf/repeated_field.h>  // IWYU pragma: export
#include <google/protobuf/extension_set.h>  // IWYU pragma: export
#include <google/protobuf/generated_enum_util.h>
#include "RemoteFortressReader.pb.h"
// @@protoc_insertion_point(includes)
#define PROTOBUF_INTERNAL_EXPORT_protobuf_AdventureControl_2eproto 

namespace protobuf_AdventureControl_2eproto {
// Internal implementation detail -- do not use these members.
struct TableStruct {
  static const ::google::protobuf::internal::ParseTableField entries[];
  static const ::google::protobuf::internal::AuxillaryParseTableField aux[];
  static const ::google::protobuf::internal::ParseTable schema[4];
  static const ::google::protobuf::internal::FieldMetadata field_metadata[];
  static const ::google::protobuf::internal::SerializationTable serialization_table[];
  static const ::google::protobuf::uint32 offsets[];
};
}  // namespace protobuf_AdventureControl_2eproto
namespace AdventureControl {
class MenuContents;
class MenuContentsDefaultTypeInternal;
extern MenuContentsDefaultTypeInternal _MenuContents_default_instance_;
class MiscMoveParams;
class MiscMoveParamsDefaultTypeInternal;
extern MiscMoveParamsDefaultTypeInternal _MiscMoveParams_default_instance_;
class MoveCommandParams;
class MoveCommandParamsDefaultTypeInternal;
extern MoveCommandParamsDefaultTypeInternal _MoveCommandParams_default_instance_;
class MovementOption;
class MovementOptionDefaultTypeInternal;
extern MovementOptionDefaultTypeInternal _MovementOption_default_instance_;
}  // namespace AdventureControl
namespace google {
namespace protobuf {
template<> ::AdventureControl::MenuContents* Arena::CreateMaybeMessage<::AdventureControl::MenuContents>(Arena*);
template<> ::AdventureControl::MiscMoveParams* Arena::CreateMaybeMessage<::AdventureControl::MiscMoveParams>(Arena*);
template<> ::AdventureControl::MoveCommandParams* Arena::CreateMaybeMessage<::AdventureControl::MoveCommandParams>(Arena*);
template<> ::AdventureControl::MovementOption* Arena::CreateMaybeMessage<::AdventureControl::MovementOption>(Arena*);
}  // namespace protobuf
}  // namespace google
namespace AdventureControl {

enum AdvmodeMenu {
  Default = 0,
  Look = 1,
  ConversationAddress = 2,
  ConversationSelect = 3,
  ConversationSpeak = 4,
  Inventory = 5,
  Drop = 6,
  ThrowItem = 7,
  Wear = 8,
  Remove = 9,
  Interact = 10,
  Put = 11,
  PutContainer = 12,
  Eat = 13,
  ThrowAim = 14,
  Fire = 15,
  Get = 16,
  Unk17 = 17,
  CombatPrefs = 18,
  Companions = 19,
  MovementPrefs = 20,
  SpeedPrefs = 21,
  InteractAction = 22,
  MoveCarefully = 23,
  Announcements = 24,
  UseBuilding = 25,
  Travel = 26,
  Unk27 = 27,
  Unk28 = 28,
  SleepConfirm = 29,
  SelectInteractionTarget = 30,
  Unk31 = 31,
  Unk32 = 32,
  FallAction = 33,
  ViewTracks = 34,
  Jump = 35,
  Unk36 = 36,
  AttackConfirm = 37,
  AttackType = 38,
  AttackBodypart = 39,
  AttackStrike = 40,
  Unk41 = 41,
  Unk42 = 42,
  DodgeDirection = 43,
  Unk44 = 44,
  Unk45 = 45,
  Build = 46
};
bool AdvmodeMenu_IsValid(int value);
const AdvmodeMenu AdvmodeMenu_MIN = Default;
const AdvmodeMenu AdvmodeMenu_MAX = Build;
const int AdvmodeMenu_ARRAYSIZE = AdvmodeMenu_MAX + 1;

enum CarefulMovementType {
  DEFAULT_MOVEMENT = 0,
  RELEASE_ITEM_HOLD = 1,
  RELEASE_TILE_HOLD = 2,
  ATTACK_CREATURE = 3,
  HOLD_TILE = 4,
  MOVE = 5,
  CLIMB = 6,
  HOLD_ITEM = 7,
  BUILDING_INTERACT = 8,
  ITEM_INTERACT = 9,
  ITEM_INTERACT_GUIDE = 10,
  ITEM_INTERACT_RIDE = 11,
  ITEM_INTERACT_PUSH = 12
};
bool CarefulMovementType_IsValid(int value);
const CarefulMovementType CarefulMovementType_MIN = DEFAULT_MOVEMENT;
const CarefulMovementType CarefulMovementType_MAX = ITEM_INTERACT_PUSH;
const int CarefulMovementType_ARRAYSIZE = CarefulMovementType_MAX + 1;

enum MiscMoveType {
  SET_CLIMB = 0,
  SET_STAND = 1,
  SET_CANCEL = 2
};
bool MiscMoveType_IsValid(int value);
const MiscMoveType MiscMoveType_MIN = SET_CLIMB;
const MiscMoveType MiscMoveType_MAX = SET_CANCEL;
const int MiscMoveType_ARRAYSIZE = MiscMoveType_MAX + 1;

// ===================================================================

class MoveCommandParams : public ::google::protobuf::MessageLite /* @@protoc_insertion_point(class_definition:AdventureControl.MoveCommandParams) */ {
 public:
  MoveCommandParams();
  virtual ~MoveCommandParams();

  MoveCommandParams(const MoveCommandParams& from);

  inline MoveCommandParams& operator=(const MoveCommandParams& from) {
    CopyFrom(from);
    return *this;
  }
  #if LANG_CXX11
  MoveCommandParams(MoveCommandParams&& from) noexcept
    : MoveCommandParams() {
    *this = ::std::move(from);
  }

  inline MoveCommandParams& operator=(MoveCommandParams&& from) noexcept {
    if (GetArenaNoVirtual() == from.GetArenaNoVirtual()) {
      if (this != &from) InternalSwap(&from);
    } else {
      CopyFrom(from);
    }
    return *this;
  }
  #endif
  inline const ::std::string& unknown_fields() const {
    return _internal_metadata_.unknown_fields();
  }
  inline ::std::string* mutable_unknown_fields() {
    return _internal_metadata_.mutable_unknown_fields();
  }

  static const MoveCommandParams& default_instance();

  static void InitAsDefaultInstance();  // FOR INTERNAL USE ONLY
  static inline const MoveCommandParams* internal_default_instance() {
    return reinterpret_cast<const MoveCommandParams*>(
               &_MoveCommandParams_default_instance_);
  }
  static constexpr int kIndexInFileMessages =
    0;

  void Swap(MoveCommandParams* other);
  friend void swap(MoveCommandParams& a, MoveCommandParams& b) {
    a.Swap(&b);
  }

  // implements Message ----------------------------------------------

  inline MoveCommandParams* New() const final {
    return CreateMaybeMessage<MoveCommandParams>(NULL);
  }

  MoveCommandParams* New(::google::protobuf::Arena* arena) const final {
    return CreateMaybeMessage<MoveCommandParams>(arena);
  }
  void CheckTypeAndMergeFrom(const ::google::protobuf::MessageLite& from)
    final;
  void CopyFrom(const MoveCommandParams& from);
  void MergeFrom(const MoveCommandParams& from);
  void Clear() final;
  bool IsInitialized() const final;

  size_t ByteSizeLong() const final;
  bool MergePartialFromCodedStream(
      ::google::protobuf::io::CodedInputStream* input) final;
  void SerializeWithCachedSizes(
      ::google::protobuf::io::CodedOutputStream* output) const final;
  void DiscardUnknownFields();
  int GetCachedSize() const final { return _cached_size_.Get(); }

  private:
  void SharedCtor();
  void SharedDtor();
  void SetCachedSize(int size) const;
  void InternalSwap(MoveCommandParams* other);
  private:
  inline ::google::protobuf::Arena* GetArenaNoVirtual() const {
    return NULL;
  }
  inline void* MaybeArenaPtr() const {
    return NULL;
  }
  public:

  ::std::string GetTypeName() const final;

  // nested types ----------------------------------------------------

  // accessors -------------------------------------------------------

  // optional .RemoteFortressReader.Coord direction = 1;
  bool has_direction() const;
  void clear_direction();
  static const int kDirectionFieldNumber = 1;
  private:
  const ::RemoteFortressReader::Coord& _internal_direction() const;
  public:
  const ::RemoteFortressReader::Coord& direction() const;
  ::RemoteFortressReader::Coord* release_direction();
  ::RemoteFortressReader::Coord* mutable_direction();
  void set_allocated_direction(::RemoteFortressReader::Coord* direction);

  // @@protoc_insertion_point(class_scope:AdventureControl.MoveCommandParams)
 private:
  void set_has_direction();
  void clear_has_direction();

  ::google::protobuf::internal::InternalMetadataWithArenaLite _internal_metadata_;
  ::google::protobuf::internal::HasBits<1> _has_bits_;
  mutable ::google::protobuf::internal::CachedSize _cached_size_;
  ::RemoteFortressReader::Coord* direction_;
  friend struct ::protobuf_AdventureControl_2eproto::TableStruct;
};
// -------------------------------------------------------------------

class MovementOption : public ::google::protobuf::MessageLite /* @@protoc_insertion_point(class_definition:AdventureControl.MovementOption) */ {
 public:
  MovementOption();
  virtual ~MovementOption();

  MovementOption(const MovementOption& from);

  inline MovementOption& operator=(const MovementOption& from) {
    CopyFrom(from);
    return *this;
  }
  #if LANG_CXX11
  MovementOption(MovementOption&& from) noexcept
    : MovementOption() {
    *this = ::std::move(from);
  }

  inline MovementOption& operator=(MovementOption&& from) noexcept {
    if (GetArenaNoVirtual() == from.GetArenaNoVirtual()) {
      if (this != &from) InternalSwap(&from);
    } else {
      CopyFrom(from);
    }
    return *this;
  }
  #endif
  inline const ::std::string& unknown_fields() const {
    return _internal_metadata_.unknown_fields();
  }
  inline ::std::string* mutable_unknown_fields() {
    return _internal_metadata_.mutable_unknown_fields();
  }

  static const MovementOption& default_instance();

  static void InitAsDefaultInstance();  // FOR INTERNAL USE ONLY
  static inline const MovementOption* internal_default_instance() {
    return reinterpret_cast<const MovementOption*>(
               &_MovementOption_default_instance_);
  }
  static constexpr int kIndexInFileMessages =
    1;

  void Swap(MovementOption* other);
  friend void swap(MovementOption& a, MovementOption& b) {
    a.Swap(&b);
  }

  // implements Message ----------------------------------------------

  inline MovementOption* New() const final {
    return CreateMaybeMessage<MovementOption>(NULL);
  }

  MovementOption* New(::google::protobuf::Arena* arena) const final {
    return CreateMaybeMessage<MovementOption>(arena);
  }
  void CheckTypeAndMergeFrom(const ::google::protobuf::MessageLite& from)
    final;
  void CopyFrom(const MovementOption& from);
  void MergeFrom(const MovementOption& from);
  void Clear() final;
  bool IsInitialized() const final;

  size_t ByteSizeLong() const final;
  bool MergePartialFromCodedStream(
      ::google::protobuf::io::CodedInputStream* input) final;
  void SerializeWithCachedSizes(
      ::google::protobuf::io::CodedOutputStream* output) const final;
  void DiscardUnknownFields();
  int GetCachedSize() const final { return _cached_size_.Get(); }

  private:
  void SharedCtor();
  void SharedDtor();
  void SetCachedSize(int size) const;
  void InternalSwap(MovementOption* other);
  private:
  inline ::google::protobuf::Arena* GetArenaNoVirtual() const {
    return NULL;
  }
  inline void* MaybeArenaPtr() const {
    return NULL;
  }
  public:

  ::std::string GetTypeName() const final;

  // nested types ----------------------------------------------------

  // accessors -------------------------------------------------------

  // optional .RemoteFortressReader.Coord dest = 1;
  bool has_dest() const;
  void clear_dest();
  static const int kDestFieldNumber = 1;
  private:
  const ::RemoteFortressReader::Coord& _internal_dest() const;
  public:
  const ::RemoteFortressReader::Coord& dest() const;
  ::RemoteFortressReader::Coord* release_dest();
  ::RemoteFortressReader::Coord* mutable_dest();
  void set_allocated_dest(::RemoteFortressReader::Coord* dest);

  // optional .RemoteFortressReader.Coord source = 2;
  bool has_source() const;
  void clear_source();
  static const int kSourceFieldNumber = 2;
  private:
  const ::RemoteFortressReader::Coord& _internal_source() const;
  public:
  const ::RemoteFortressReader::Coord& source() const;
  ::RemoteFortressReader::Coord* release_source();
  ::RemoteFortressReader::Coord* mutable_source();
  void set_allocated_source(::RemoteFortressReader::Coord* source);

  // optional .RemoteFortressReader.Coord grab = 3;
  bool has_grab() const;
  void clear_grab();
  static const int kGrabFieldNumber = 3;
  private:
  const ::RemoteFortressReader::Coord& _internal_grab() const;
  public:
  const ::RemoteFortressReader::Coord& grab() const;
  ::RemoteFortressReader::Coord* release_grab();
  ::RemoteFortressReader::Coord* mutable_grab();
  void set_allocated_grab(::RemoteFortressReader::Coord* grab);

  // optional .AdventureControl.CarefulMovementType movement_type = 4;
  bool has_movement_type() const;
  void clear_movement_type();
  static const int kMovementTypeFieldNumber = 4;
  ::AdventureControl::CarefulMovementType movement_type() const;
  void set_movement_type(::AdventureControl::CarefulMovementType value);

  // @@protoc_insertion_point(class_scope:AdventureControl.MovementOption)
 private:
  void set_has_dest();
  void clear_has_dest();
  void set_has_source();
  void clear_has_source();
  void set_has_grab();
  void clear_has_grab();
  void set_has_movement_type();
  void clear_has_movement_type();

  ::google::protobuf::internal::InternalMetadataWithArenaLite _internal_metadata_;
  ::google::protobuf::internal::HasBits<1> _has_bits_;
  mutable ::google::protobuf::internal::CachedSize _cached_size_;
  ::RemoteFortressReader::Coord* dest_;
  ::RemoteFortressReader::Coord* source_;
  ::RemoteFortressReader::Coord* grab_;
  int movement_type_;
  friend struct ::protobuf_AdventureControl_2eproto::TableStruct;
};
// -------------------------------------------------------------------

class MenuContents : public ::google::protobuf::MessageLite /* @@protoc_insertion_point(class_definition:AdventureControl.MenuContents) */ {
 public:
  MenuContents();
  virtual ~MenuContents();

  MenuContents(const MenuContents& from);

  inline MenuContents& operator=(const MenuContents& from) {
    CopyFrom(from);
    return *this;
  }
  #if LANG_CXX11
  MenuContents(MenuContents&& from) noexcept
    : MenuContents() {
    *this = ::std::move(from);
  }

  inline MenuContents& operator=(MenuContents&& from) noexcept {
    if (GetArenaNoVirtual() == from.GetArenaNoVirtual()) {
      if (this != &from) InternalSwap(&from);
    } else {
      CopyFrom(from);
    }
    return *this;
  }
  #endif
  inline const ::std::string& unknown_fields() const {
    return _internal_metadata_.unknown_fields();
  }
  inline ::std::string* mutable_unknown_fields() {
    return _internal_metadata_.mutable_unknown_fields();
  }

  static const MenuContents& default_instance();

  static void InitAsDefaultInstance();  // FOR INTERNAL USE ONLY
  static inline const MenuContents* internal_default_instance() {
    return reinterpret_cast<const MenuContents*>(
               &_MenuContents_default_instance_);
  }
  static constexpr int kIndexInFileMessages =
    2;

  void Swap(MenuContents* other);
  friend void swap(MenuContents& a, MenuContents& b) {
    a.Swap(&b);
  }

  // implements Message ----------------------------------------------

  inline MenuContents* New() const final {
    return CreateMaybeMessage<MenuContents>(NULL);
  }

  MenuContents* New(::google::protobuf::Arena* arena) const final {
    return CreateMaybeMessage<MenuContents>(arena);
  }
  void CheckTypeAndMergeFrom(const ::google::protobuf::MessageLite& from)
    final;
  void CopyFrom(const MenuContents& from);
  void MergeFrom(const MenuContents& from);
  void Clear() final;
  bool IsInitialized() const final;

  size_t ByteSizeLong() const final;
  bool MergePartialFromCodedStream(
      ::google::protobuf::io::CodedInputStream* input) final;
  void SerializeWithCachedSizes(
      ::google::protobuf::io::CodedOutputStream* output) const final;
  void DiscardUnknownFields();
  int GetCachedSize() const final { return _cached_size_.Get(); }

  private:
  void SharedCtor();
  void SharedDtor();
  void SetCachedSize(int size) const;
  void InternalSwap(MenuContents* other);
  private:
  inline ::google::protobuf::Arena* GetArenaNoVirtual() const {
    return NULL;
  }
  inline void* MaybeArenaPtr() const {
    return NULL;
  }
  public:

  ::std::string GetTypeName() const final;

  // nested types ----------------------------------------------------

  // accessors -------------------------------------------------------

  // repeated .AdventureControl.MovementOption movements = 2;
  int movements_size() const;
  void clear_movements();
  static const int kMovementsFieldNumber = 2;
  ::AdventureControl::MovementOption* mutable_movements(int index);
  ::google::protobuf::RepeatedPtrField< ::AdventureControl::MovementOption >*
      mutable_movements();
  const ::AdventureControl::MovementOption& movements(int index) const;
  ::AdventureControl::MovementOption* add_movements();
  const ::google::protobuf::RepeatedPtrField< ::AdventureControl::MovementOption >&
      movements() const;

  // optional .AdventureControl.AdvmodeMenu current_menu = 1;
  bool has_current_menu() const;
  void clear_current_menu();
  static const int kCurrentMenuFieldNumber = 1;
  ::AdventureControl::AdvmodeMenu current_menu() const;
  void set_current_menu(::AdventureControl::AdvmodeMenu value);

  // @@protoc_insertion_point(class_scope:AdventureControl.MenuContents)
 private:
  void set_has_current_menu();
  void clear_has_current_menu();

  ::google::protobuf::internal::InternalMetadataWithArenaLite _internal_metadata_;
  ::google::protobuf::internal::HasBits<1> _has_bits_;
  mutable ::google::protobuf::internal::CachedSize _cached_size_;
  ::google::protobuf::RepeatedPtrField< ::AdventureControl::MovementOption > movements_;
  int current_menu_;
  friend struct ::protobuf_AdventureControl_2eproto::TableStruct;
};
// -------------------------------------------------------------------

class MiscMoveParams : public ::google::protobuf::MessageLite /* @@protoc_insertion_point(class_definition:AdventureControl.MiscMoveParams) */ {
 public:
  MiscMoveParams();
  virtual ~MiscMoveParams();

  MiscMoveParams(const MiscMoveParams& from);

  inline MiscMoveParams& operator=(const MiscMoveParams& from) {
    CopyFrom(from);
    return *this;
  }
  #if LANG_CXX11
  MiscMoveParams(MiscMoveParams&& from) noexcept
    : MiscMoveParams() {
    *this = ::std::move(from);
  }

  inline MiscMoveParams& operator=(MiscMoveParams&& from) noexcept {
    if (GetArenaNoVirtual() == from.GetArenaNoVirtual()) {
      if (this != &from) InternalSwap(&from);
    } else {
      CopyFrom(from);
    }
    return *this;
  }
  #endif
  inline const ::std::string& unknown_fields() const {
    return _internal_metadata_.unknown_fields();
  }
  inline ::std::string* mutable_unknown_fields() {
    return _internal_metadata_.mutable_unknown_fields();
  }

  static const MiscMoveParams& default_instance();

  static void InitAsDefaultInstance();  // FOR INTERNAL USE ONLY
  static inline const MiscMoveParams* internal_default_instance() {
    return reinterpret_cast<const MiscMoveParams*>(
               &_MiscMoveParams_default_instance_);
  }
  static constexpr int kIndexInFileMessages =
    3;

  void Swap(MiscMoveParams* other);
  friend void swap(MiscMoveParams& a, MiscMoveParams& b) {
    a.Swap(&b);
  }

  // implements Message ----------------------------------------------

  inline MiscMoveParams* New() const final {
    return CreateMaybeMessage<MiscMoveParams>(NULL);
  }

  MiscMoveParams* New(::google::protobuf::Arena* arena) const final {
    return CreateMaybeMessage<MiscMoveParams>(arena);
  }
  void CheckTypeAndMergeFrom(const ::google::protobuf::MessageLite& from)
    final;
  void CopyFrom(const MiscMoveParams& from);
  void MergeFrom(const MiscMoveParams& from);
  void Clear() final;
  bool IsInitialized() const final;

  size_t ByteSizeLong() const final;
  bool MergePartialFromCodedStream(
      ::google::protobuf::io::CodedInputStream* input) final;
  void SerializeWithCachedSizes(
      ::google::protobuf::io::CodedOutputStream* output) const final;
  void DiscardUnknownFields();
  int GetCachedSize() const final { return _cached_size_.Get(); }

  private:
  void SharedCtor();
  void SharedDtor();
  void SetCachedSize(int size) const;
  void InternalSwap(MiscMoveParams* other);
  private:
  inline ::google::protobuf::Arena* GetArenaNoVirtual() const {
    return NULL;
  }
  inline void* MaybeArenaPtr() const {
    return NULL;
  }
  public:

  ::std::string GetTypeName() const final;

  // nested types ----------------------------------------------------

  // accessors -------------------------------------------------------

  // optional .AdventureControl.MiscMoveType type = 1;
  bool has_type() const;
  void clear_type();
  static const int kTypeFieldNumber = 1;
  ::AdventureControl::MiscMoveType type() const;
  void set_type(::AdventureControl::MiscMoveType value);

  // @@protoc_insertion_point(class_scope:AdventureControl.MiscMoveParams)
 private:
  void set_has_type();
  void clear_has_type();

  ::google::protobuf::internal::InternalMetadataWithArenaLite _internal_metadata_;
  ::google::protobuf::internal::HasBits<1> _has_bits_;
  mutable ::google::protobuf::internal::CachedSize _cached_size_;
  int type_;
  friend struct ::protobuf_AdventureControl_2eproto::TableStruct;
};
// ===================================================================


// ===================================================================

#ifdef __GNUC__
  #pragma GCC diagnostic push
  #pragma GCC diagnostic ignored "-Wstrict-aliasing"
#endif  // __GNUC__
// MoveCommandParams

// optional .RemoteFortressReader.Coord direction = 1;
inline bool MoveCommandParams::has_direction() const {
  return (_has_bits_[0] & 0x00000001u) != 0;
}
inline void MoveCommandParams::set_has_direction() {
  _has_bits_[0] |= 0x00000001u;
}
inline void MoveCommandParams::clear_has_direction() {
  _has_bits_[0] &= ~0x00000001u;
}
inline const ::RemoteFortressReader::Coord& MoveCommandParams::_internal_direction() const {
  return *direction_;
}
inline const ::RemoteFortressReader::Coord& MoveCommandParams::direction() const {
  const ::RemoteFortressReader::Coord* p = direction_;
  // @@protoc_insertion_point(field_get:AdventureControl.MoveCommandParams.direction)
  return p != NULL ? *p : *reinterpret_cast<const ::RemoteFortressReader::Coord*>(
      &::RemoteFortressReader::_Coord_default_instance_);
}
inline ::RemoteFortressReader::Coord* MoveCommandParams::release_direction() {
  // @@protoc_insertion_point(field_release:AdventureControl.MoveCommandParams.direction)
  clear_has_direction();
  ::RemoteFortressReader::Coord* temp = direction_;
  direction_ = NULL;
  return temp;
}
inline ::RemoteFortressReader::Coord* MoveCommandParams::mutable_direction() {
  set_has_direction();
  if (direction_ == NULL) {
    auto* p = CreateMaybeMessage<::RemoteFortressReader::Coord>(GetArenaNoVirtual());
    direction_ = p;
  }
  // @@protoc_insertion_point(field_mutable:AdventureControl.MoveCommandParams.direction)
  return direction_;
}
inline void MoveCommandParams::set_allocated_direction(::RemoteFortressReader::Coord* direction) {
  ::google::protobuf::Arena* message_arena = GetArenaNoVirtual();
  if (message_arena == NULL) {
    delete reinterpret_cast< ::google::protobuf::MessageLite*>(direction_);
  }
  if (direction) {
    ::google::protobuf::Arena* submessage_arena = NULL;
    if (message_arena != submessage_arena) {
      direction = ::google::protobuf::internal::GetOwnedMessage(
          message_arena, direction, submessage_arena);
    }
    set_has_direction();
  } else {
    clear_has_direction();
  }
  direction_ = direction;
  // @@protoc_insertion_point(field_set_allocated:AdventureControl.MoveCommandParams.direction)
}

// -------------------------------------------------------------------

// MovementOption

// optional .RemoteFortressReader.Coord dest = 1;
inline bool MovementOption::has_dest() const {
  return (_has_bits_[0] & 0x00000001u) != 0;
}
inline void MovementOption::set_has_dest() {
  _has_bits_[0] |= 0x00000001u;
}
inline void MovementOption::clear_has_dest() {
  _has_bits_[0] &= ~0x00000001u;
}
inline const ::RemoteFortressReader::Coord& MovementOption::_internal_dest() const {
  return *dest_;
}
inline const ::RemoteFortressReader::Coord& MovementOption::dest() const {
  const ::RemoteFortressReader::Coord* p = dest_;
  // @@protoc_insertion_point(field_get:AdventureControl.MovementOption.dest)
  return p != NULL ? *p : *reinterpret_cast<const ::RemoteFortressReader::Coord*>(
      &::RemoteFortressReader::_Coord_default_instance_);
}
inline ::RemoteFortressReader::Coord* MovementOption::release_dest() {
  // @@protoc_insertion_point(field_release:AdventureControl.MovementOption.dest)
  clear_has_dest();
  ::RemoteFortressReader::Coord* temp = dest_;
  dest_ = NULL;
  return temp;
}
inline ::RemoteFortressReader::Coord* MovementOption::mutable_dest() {
  set_has_dest();
  if (dest_ == NULL) {
    auto* p = CreateMaybeMessage<::RemoteFortressReader::Coord>(GetArenaNoVirtual());
    dest_ = p;
  }
  // @@protoc_insertion_point(field_mutable:AdventureControl.MovementOption.dest)
  return dest_;
}
inline void MovementOption::set_allocated_dest(::RemoteFortressReader::Coord* dest) {
  ::google::protobuf::Arena* message_arena = GetArenaNoVirtual();
  if (message_arena == NULL) {
    delete reinterpret_cast< ::google::protobuf::MessageLite*>(dest_);
  }
  if (dest) {
    ::google::protobuf::Arena* submessage_arena = NULL;
    if (message_arena != submessage_arena) {
      dest = ::google::protobuf::internal::GetOwnedMessage(
          message_arena, dest, submessage_arena);
    }
    set_has_dest();
  } else {
    clear_has_dest();
  }
  dest_ = dest;
  // @@protoc_insertion_point(field_set_allocated:AdventureControl.MovementOption.dest)
}

// optional .RemoteFortressReader.Coord source = 2;
inline bool MovementOption::has_source() const {
  return (_has_bits_[0] & 0x00000002u) != 0;
}
inline void MovementOption::set_has_source() {
  _has_bits_[0] |= 0x00000002u;
}
inline void MovementOption::clear_has_source() {
  _has_bits_[0] &= ~0x00000002u;
}
inline const ::RemoteFortressReader::Coord& MovementOption::_internal_source() const {
  return *source_;
}
inline const ::RemoteFortressReader::Coord& MovementOption::source() const {
  const ::RemoteFortressReader::Coord* p = source_;
  // @@protoc_insertion_point(field_get:AdventureControl.MovementOption.source)
  return p != NULL ? *p : *reinterpret_cast<const ::RemoteFortressReader::Coord*>(
      &::RemoteFortressReader::_Coord_default_instance_);
}
inline ::RemoteFortressReader::Coord* MovementOption::release_source() {
  // @@protoc_insertion_point(field_release:AdventureControl.MovementOption.source)
  clear_has_source();
  ::RemoteFortressReader::Coord* temp = source_;
  source_ = NULL;
  return temp;
}
inline ::RemoteFortressReader::Coord* MovementOption::mutable_source() {
  set_has_source();
  if (source_ == NULL) {
    auto* p = CreateMaybeMessage<::RemoteFortressReader::Coord>(GetArenaNoVirtual());
    source_ = p;
  }
  // @@protoc_insertion_point(field_mutable:AdventureControl.MovementOption.source)
  return source_;
}
inline void MovementOption::set_allocated_source(::RemoteFortressReader::Coord* source) {
  ::google::protobuf::Arena* message_arena = GetArenaNoVirtual();
  if (message_arena == NULL) {
    delete reinterpret_cast< ::google::protobuf::MessageLite*>(source_);
  }
  if (source) {
    ::google::protobuf::Arena* submessage_arena = NULL;
    if (message_arena != submessage_arena) {
      source = ::google::protobuf::internal::GetOwnedMessage(
          message_arena, source, submessage_arena);
    }
    set_has_source();
  } else {
    clear_has_source();
  }
  source_ = source;
  // @@protoc_insertion_point(field_set_allocated:AdventureControl.MovementOption.source)
}

// optional .RemoteFortressReader.Coord grab = 3;
inline bool MovementOption::has_grab() const {
  return (_has_bits_[0] & 0x00000004u) != 0;
}
inline void MovementOption::set_has_grab() {
  _has_bits_[0] |= 0x00000004u;
}
inline void MovementOption::clear_has_grab() {
  _has_bits_[0] &= ~0x00000004u;
}
inline const ::RemoteFortressReader::Coord& MovementOption::_internal_grab() const {
  return *grab_;
}
inline const ::RemoteFortressReader::Coord& MovementOption::grab() const {
  const ::RemoteFortressReader::Coord* p = grab_;
  // @@protoc_insertion_point(field_get:AdventureControl.MovementOption.grab)
  return p != NULL ? *p : *reinterpret_cast<const ::RemoteFortressReader::Coord*>(
      &::RemoteFortressReader::_Coord_default_instance_);
}
inline ::RemoteFortressReader::Coord* MovementOption::release_grab() {
  // @@protoc_insertion_point(field_release:AdventureControl.MovementOption.grab)
  clear_has_grab();
  ::RemoteFortressReader::Coord* temp = grab_;
  grab_ = NULL;
  return temp;
}
inline ::RemoteFortressReader::Coord* MovementOption::mutable_grab() {
  set_has_grab();
  if (grab_ == NULL) {
    auto* p = CreateMaybeMessage<::RemoteFortressReader::Coord>(GetArenaNoVirtual());
    grab_ = p;
  }
  // @@protoc_insertion_point(field_mutable:AdventureControl.MovementOption.grab)
  return grab_;
}
inline void MovementOption::set_allocated_grab(::RemoteFortressReader::Coord* grab) {
  ::google::protobuf::Arena* message_arena = GetArenaNoVirtual();
  if (message_arena == NULL) {
    delete reinterpret_cast< ::google::protobuf::MessageLite*>(grab_);
  }
  if (grab) {
    ::google::protobuf::Arena* submessage_arena = NULL;
    if (message_arena != submessage_arena) {
      grab = ::google::protobuf::internal::GetOwnedMessage(
          message_arena, grab, submessage_arena);
    }
    set_has_grab();
  } else {
    clear_has_grab();
  }
  grab_ = grab;
  // @@protoc_insertion_point(field_set_allocated:AdventureControl.MovementOption.grab)
}

// optional .AdventureControl.CarefulMovementType movement_type = 4;
inline bool MovementOption::has_movement_type() const {
  return (_has_bits_[0] & 0x00000008u) != 0;
}
inline void MovementOption::set_has_movement_type() {
  _has_bits_[0] |= 0x00000008u;
}
inline void MovementOption::clear_has_movement_type() {
  _has_bits_[0] &= ~0x00000008u;
}
inline void MovementOption::clear_movement_type() {
  movement_type_ = 0;
  clear_has_movement_type();
}
inline ::AdventureControl::CarefulMovementType MovementOption::movement_type() const {
  // @@protoc_insertion_point(field_get:AdventureControl.MovementOption.movement_type)
  return static_cast< ::AdventureControl::CarefulMovementType >(movement_type_);
}
inline void MovementOption::set_movement_type(::AdventureControl::CarefulMovementType value) {
  assert(::AdventureControl::CarefulMovementType_IsValid(value));
  set_has_movement_type();
  movement_type_ = value;
  // @@protoc_insertion_point(field_set:AdventureControl.MovementOption.movement_type)
}

// -------------------------------------------------------------------

// MenuContents

// optional .AdventureControl.AdvmodeMenu current_menu = 1;
inline bool MenuContents::has_current_menu() const {
  return (_has_bits_[0] & 0x00000001u) != 0;
}
inline void MenuContents::set_has_current_menu() {
  _has_bits_[0] |= 0x00000001u;
}
inline void MenuContents::clear_has_current_menu() {
  _has_bits_[0] &= ~0x00000001u;
}
inline void MenuContents::clear_current_menu() {
  current_menu_ = 0;
  clear_has_current_menu();
}
inline ::AdventureControl::AdvmodeMenu MenuContents::current_menu() const {
  // @@protoc_insertion_point(field_get:AdventureControl.MenuContents.current_menu)
  return static_cast< ::AdventureControl::AdvmodeMenu >(current_menu_);
}
inline void MenuContents::set_current_menu(::AdventureControl::AdvmodeMenu value) {
  assert(::AdventureControl::AdvmodeMenu_IsValid(value));
  set_has_current_menu();
  current_menu_ = value;
  // @@protoc_insertion_point(field_set:AdventureControl.MenuContents.current_menu)
}

// repeated .AdventureControl.MovementOption movements = 2;
inline int MenuContents::movements_size() const {
  return movements_.size();
}
inline void MenuContents::clear_movements() {
  movements_.Clear();
}
inline ::AdventureControl::MovementOption* MenuContents::mutable_movements(int index) {
  // @@protoc_insertion_point(field_mutable:AdventureControl.MenuContents.movements)
  return movements_.Mutable(index);
}
inline ::google::protobuf::RepeatedPtrField< ::AdventureControl::MovementOption >*
MenuContents::mutable_movements() {
  // @@protoc_insertion_point(field_mutable_list:AdventureControl.MenuContents.movements)
  return &movements_;
}
inline const ::AdventureControl::MovementOption& MenuContents::movements(int index) const {
  // @@protoc_insertion_point(field_get:AdventureControl.MenuContents.movements)
  return movements_.Get(index);
}
inline ::AdventureControl::MovementOption* MenuContents::add_movements() {
  // @@protoc_insertion_point(field_add:AdventureControl.MenuContents.movements)
  return movements_.Add();
}
inline const ::google::protobuf::RepeatedPtrField< ::AdventureControl::MovementOption >&
MenuContents::movements() const {
  // @@protoc_insertion_point(field_list:AdventureControl.MenuContents.movements)
  return movements_;
}

// -------------------------------------------------------------------

// MiscMoveParams

// optional .AdventureControl.MiscMoveType type = 1;
inline bool MiscMoveParams::has_type() const {
  return (_has_bits_[0] & 0x00000001u) != 0;
}
inline void MiscMoveParams::set_has_type() {
  _has_bits_[0] |= 0x00000001u;
}
inline void MiscMoveParams::clear_has_type() {
  _has_bits_[0] &= ~0x00000001u;
}
inline void MiscMoveParams::clear_type() {
  type_ = 0;
  clear_has_type();
}
inline ::AdventureControl::MiscMoveType MiscMoveParams::type() const {
  // @@protoc_insertion_point(field_get:AdventureControl.MiscMoveParams.type)
  return static_cast< ::AdventureControl::MiscMoveType >(type_);
}
inline void MiscMoveParams::set_type(::AdventureControl::MiscMoveType value) {
  assert(::AdventureControl::MiscMoveType_IsValid(value));
  set_has_type();
  type_ = value;
  // @@protoc_insertion_point(field_set:AdventureControl.MiscMoveParams.type)
}

#ifdef __GNUC__
  #pragma GCC diagnostic pop
#endif  // __GNUC__
// -------------------------------------------------------------------

// -------------------------------------------------------------------

// -------------------------------------------------------------------


// @@protoc_insertion_point(namespace_scope)

}  // namespace AdventureControl

namespace google {
namespace protobuf {

template <> struct is_proto_enum< ::AdventureControl::AdvmodeMenu> : ::std::true_type {};
template <> struct is_proto_enum< ::AdventureControl::CarefulMovementType> : ::std::true_type {};
template <> struct is_proto_enum< ::AdventureControl::MiscMoveType> : ::std::true_type {};

}  // namespace protobuf
}  // namespace google

// @@protoc_insertion_point(global_scope)

#endif  // PROTOBUF_INCLUDED_AdventureControl_2eproto
